# SAÉ 4.01 - Pizzeria en REST
> Binôme
> - DELBE florian
> - MARGELY Gwendal

# Sommaire 
1. [INGREDIENTS](#ingredients)
2. [PATES](#pates-a-pizza)
3. [PIZZA](#pizza)
4. [COMMANDE](#commande)



## INGREDIENTS 

### GET

Tous les ingrédients: 
```bash
curl -X GET http://localhost:8080/pizzeria/ingredients
```

Un seul Ingrédient:

```bash
curl -X GET http://localhost:8080/pizzeria/ingredients/idIngredient
```

### POST

ajouter un ingredient
```bash
curl -X POST http://localhost:8080/pizzeria/ingredients -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<id>","nom":"<nom>","prix":"<prix>"}'
```

### DELETE

supprimer un ingredient
```bash
curl -X DELETE http://localhost:8080/pizzeria/ingredients/idIngredient -H "Autorization: Bearer <token>"
```

### PATCH

modifier un ingredient

```bash
curl -X PATCH http://localhost:8080/pizzeria/ingredients/idIngredient -H "Autorization: Bearer <token>"  -H "Content-Type:application/json" -H "Accept:application/json" -d'<newDatas>'
```

## PATES A PIZZA


### GET

Toutes les pates: 
```bash
curl -X GET http://localhost:8080/pizzeria/pates
```

Une seule pate:

```bash
curl -X GET http://localhost:8080/pizzeria/pates/idPates
```

### POST

ajouter une pate
```bash
curl -X POST http://localhost:8080/pizzeria/pates -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<id>","nom":"<nom>"}'
```

### DELETE

supprimer une pate
```bash
curl -X DELETE http://localhost:8080/pizzeria/pates/idPates -H "Autorization: Bearer <token>"
```

### PATCH

modifier une pate

```bash
curl -X PATCH http://localhost:8080/pizzeria/pates/idPates -H "Autorization: Bearer <token>"  -H "Content-Type:application/json" -H "Accept:application/json" -d'<newDatas>'
```

## Pizza


### GET

Toutes les pizzas: 
```bash
curl -X GET http://localhost:8080/pizzeria/pizzas
```

Une seule pizza:

```bash
curl -X GET http://localhost:8080/pizzeria/pizzas/idPizza
```

### POST

ajouter une pizza
```bash
curl -X POST http://localhost:8080/pizzeria/pizzas -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<id>","nom":"<nom>","prix":"<prix>","pate":"{"id":"<pateID>"}","ingredients":"[{"id":"<idIngredient1>"},{"id":"<idIngredient2>"}]"}'
```

ajouter un ingrédient a une pizza
```bash
curl -X POST http://localhost:8080/pizzeria/pizzas/idPizza -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<idIngredient>"}'
```


### DELETE

supprimer une pizza
```bash
curl -X DELETE http://localhost:8080/pizzeria/pizzas/idPizza -H "Autorization: Bearer <token>"
```

supprimer un ingrédient d'une pizza 
```bash
curl -X POST http://localhost:8080/pizzeria/pizzas/idPizza/idIngrédient -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<idIngredient>"}'
```

### PATCH

modifier une pizza

```bash
curl -X PATCH http://localhost:8080/pizzeria/pizzas/idPizza -H "Autorization: Bearer <token>"  -H "Content-Type:application/json" -H "Accept:application/json" -d'<newDatas>'
```

## COMMANDE

### GET

Toutes les pizzas: 
```bash
curl -X GET http://localhost:8080/pizzeria/commandes
```

Une seule pizza:

```bash
curl -X GET http://localhost:8080/pizzeria/commandes/idCommande
```

### POST

ajouter une commande
```bash
curl -X POST http://localhost:8080/pizzeria/commandes -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<id>","utilisateur":"<nom>","prix":"<prix>","date":"{"id":"<pateID>"}","pizzas":"[{"id":"<idIngredient1>"},{"id":"<idIngredient2>"}]"}'
```

ajouter une pizza dans une commande
```bash
curl -X POST http://localhost:8080/pizzeria/commandes/idCommande -H "Autorization: Bearer <token>" -H "Content-Type:application/json" -H "Accept:application/json" -d '{"id":"<idPizza>"}'
```

### DELETE

supprimer une commande
```bash
curl -X DELETE http://localhost:8080/pizzeria/commandes/idCommande -H "Autorization: Bearer <token>"
```

supprimer une pizza d'une commande

```bash
curl -X DELETE http://localhost:8080/pizzeria/commandes/idCommande/idPizza -H "Autorization: Bearer <token>"
```

### PATCH

modifier une commande

```bash
curl -X PATCH http://localhost:8080/pizzeria/commandes/idCommande -H "Autorization: Bearer <token>"  -H "Content-Type:application/json" -H "Accept:application/json" -d'<newDatas>'
```